searchNodes=[{"doc":"Help Elixir applications more easily take advantage of distributed Elixir applications using Ecto and PostgreSQL in a primary/replica configuration on Fly.io.","ref":"Fly.Postgres.html","title":"Fly.Postgres","type":"module"},{"doc":"","ref":"Fly.Postgres.html#config_repo_url/1","title":"Fly.Postgres.config_repo_url/1","type":"function"},{"doc":"Returns the Repo module used by the Tracker that is not the wrapped version. Used for making direct writable calls. Example Application is used to configure the tracker. # Given Application config like this: { Fly.Postgres.LSN.Tracker , repo : MyApp.Repo.Local } Fly.Postgres ( ) #=&gt; MyApp.Repo.Local Fly.Postgres ( tracker : Fly.Postgres.LSN.Tracker ) #=&gt; MyApp.Repo.Local # Given Application config like this: { Fly.Postgres.LSN.Tracker , repo : MyApp.Repo.Local_1 , name : :repo_tracker_1 } , { Fly.Postgres.LSN.Tracker , repo : MyApp.Repo.Local_2 , name : :repo_tracker_2 } , Fly.Postgres ( tracker : :repo_tracker_1 ) #=&gt; MyApp.Repo.Local_1 Fly.Postgres ( tracker : :repo_tracker_2 ) #=&gt; MyApp.Repo.Local_2","ref":"Fly.Postgres.html#local_repo/1","title":"Fly.Postgres.local_repo/1","type":"function"},{"doc":"Function used to make the repository be read-only and error when creates, updates, or deletes are attempted. This behaves like a read-only replica which is helpful when modelling that setup locally in a dev environment. Example In your config/dev.exs , # Configure your database config :my_app , MyApp.Repo.Local , username : &quot;postgres&quot; , password : &quot;postgres&quot; , database : &quot;my_db_dev&quot; , hostname : &quot;localhost&quot; , show_sensitive_data_on_connection_error : true , # Forcing the repo to be R/O locally for dev testing after_connect : { Fly , :make_connection_read_only! , [ ] } , pool_size : 10","ref":"Fly.Postgres.html#make_connection_read_only!/1","title":"Fly.Postgres.make_connection_read_only!/1","type":"function"},{"doc":"Compute the database url to use for this app given the current configuration and runtime environment.","ref":"Fly.Postgres.html#rewrite_database_url/1","title":"Fly.Postgres.rewrite_database_url/1","type":"function"},{"doc":"Rewrite the :url value to include DNS helpers of &quot;top2.nearest.of&quot; to find the closes database to target. If the host already contains that, leave it unchanged. If it is missing, add it and return the updated the url in the config.","ref":"Fly.Postgres.html#rewrite_host/1","title":"Fly.Postgres.rewrite_host/1","type":"function"},{"doc":"Rewrite the :url value to target the Postgres replica port of 5433.","ref":"Fly.Postgres.html#rewrite_replica_port/1","title":"Fly.Postgres.rewrite_replica_port/1","type":"function"},{"doc":"Execute the MFA (Module, Function, Arguments) on a node in the primary region. This waits for the data to be replicated to the current node before continuing on. This presumes the primary region has direct access to a writable primary Postgres database. Options :tracker - The name of the tracker to wait on for replication tracking. :rpc_timeout - Timeout duration to wait for RPC call to complete :replication_timeout - Timeout duration to wait for replication to complete.","ref":"Fly.Postgres.html#rpc_and_wait/4","title":"Fly.Postgres.rpc_and_wait/4","type":"function"},{"doc":"Data structure that represents a PostgreSQL LSN or Log Sequence Number. Two LSN values can be compared using the replicated?/2 function. An LSN associated with the DB modification has a source of :insert . On a replica instance, that can be used to see when the insert has been replicated locally.","ref":"Fly.Postgres.LSN.html","title":"Fly.Postgres.LSN","type":"module"},{"doc":"After performing a database modification, calling current_wal_insert/1 returns a value that can be used to compare against a WAL value from the replica database to determine when the changes have been replayed on the replica.","ref":"Fly.Postgres.LSN.html#current_wal_insert/1","title":"Fly.Postgres.LSN.current_wal_insert/1","type":"function"},{"doc":"When talking to a replica database, this returns a value for what changes have been replayed on the replica from the primary.","ref":"Fly.Postgres.LSN.html#last_wal_replay/1","title":"Fly.Postgres.LSN.last_wal_replay/1","type":"function"},{"doc":"Create a new Fly.Postgres.LSN struct from the a queried WAL value.","ref":"Fly.Postgres.LSN.html#new/2","title":"Fly.Postgres.LSN.new/2","type":"function"},{"doc":"Compare two Fly.Postgres.LSN structs to determine if the transaction representing a data change on the primary has been replayed locally. They are compared where the replay/replica value is in argument 1 and the insert value is in arguemnt two. Examples repo |&gt; last_wal_replay ( ) |&gt; replicated? ( primary_lsn )","ref":"Fly.Postgres.LSN.html#replicated?/2","title":"Fly.Postgres.LSN.replicated?/2","type":"function"},{"doc":"","ref":"Fly.Postgres.LSN.html#t:t/0","title":"Fly.Postgres.LSN.t/0","type":"type"},{"doc":"Track the current PostgreSQL LSN or Log Sequence Number. This is used to determine which portions of the database log have been replicated locally. This lets us determine if a specific transaction chunk has been replicated to know that some expected data is present. The client process doesn't interact directly with the Tracker GenServer. The client can request_notification or request_and_await_notification and the Tracker will notify the process when the data replication has been seen.","ref":"Fly.Postgres.LSN.Tracker.html","title":"Fly.Postgres.LSN.Tracker","type":"module"},{"doc":"Blocking function that waits for a request_notification/2 response message to be received. The timeout defaults to 5s after which time it stops waiting and returns an {:error, :timeout} response. Options :replication_timeout - Timeout duration to wait for replication to complete.","ref":"Fly.Postgres.LSN.Tracker.html#await_notification/2","title":"Fly.Postgres.LSN.Tracker.await_notification/2","type":"function"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Fly.Postgres.LSN.Tracker.html#child_spec/1","title":"Fly.Postgres.LSN.Tracker.child_spec/1","type":"function"},{"doc":"Get the latest cached LSN replay value. Options :tracker - The tracker name to get the latest LSN replay value for. Uses the default tracker name. Needs to be provided when multiple trackers are used.","ref":"Fly.Postgres.LSN.Tracker.html#get_last_replay/1","title":"Fly.Postgres.LSN.Tracker.get_last_replay/1","type":"function"},{"doc":"Get the Ecto.Repo used by the tracker. Options :tracker - The tracker name to get the latest LSN replay value for. Uses the default tracker name. Needs to be provided when multiple trackers are used.","ref":"Fly.Postgres.LSN.Tracker.html#get_repo/1","title":"Fly.Postgres.LSN.Tracker.get_repo/1","type":"function"},{"doc":"","ref":"Fly.Postgres.LSN.Tracker.html#get_table_name/2","title":"Fly.Postgres.LSN.Tracker.get_table_name/2","type":"function"},{"doc":"Callback implementation for GenServer.handle_continue/2 .","ref":"Fly.Postgres.LSN.Tracker.html#handle_continue/2","title":"Fly.Postgres.LSN.Tracker.handle_continue/2","type":"function"},{"doc":"Callback implementation for GenServer.init/1 .","ref":"Fly.Postgres.LSN.Tracker.html#init/1","title":"Fly.Postgres.LSN.Tracker.init/1","type":"function"},{"doc":"Return if the LSN value was replicated.","ref":"Fly.Postgres.LSN.Tracker.html#replicated?/2","title":"Fly.Postgres.LSN.Tracker.replicated?/2","type":"function"},{"doc":"Request to be notified when the desired level of data replication has completed and wait for it to complete. Optionally it may timeout if it takes too long. Options :tracker - The name of the tracker to wait on for replication tracking. :replication_timeout - Timeout duration to wait for replication to complete.","ref":"Fly.Postgres.LSN.Tracker.html#request_and_await_notification/2","title":"Fly.Postgres.LSN.Tracker.request_and_await_notification/2","type":"function"},{"doc":"Request notification for when the database replication includes the LSN the process cares about. This allows a process to block and await their data to be replicated and be notified as soon as it's detected.","ref":"Fly.Postgres.LSN.Tracker.html#request_notification/2","title":"Fly.Postgres.LSN.Tracker.request_notification/2","type":"function"},{"doc":"Start the Tracker that receives work requests.","ref":"Fly.Postgres.LSN.Tracker.html#start_link/1","title":"Fly.Postgres.LSN.Tracker.start_link/1","type":"function"},{"doc":"This wraps the built-in Ecto.Repo functions to proxy writable functions like insert, update and delete to be performed on the an Elixir node in the primary region. To use it, rename your existing repo module and add a new module with the same name as your original repo like this. Original code: defmodule MyApp.Repo do use Ecto.Repo , otp_app : :my_app , adapter : Ecto.Adapters.Postgres end Changes to: defmodule MyApp.Repo.Local do use Ecto.Repo , otp_app : :my_app , adapter : Ecto.Adapters.Postgres # Dynamically configure the database url based for runtime environment. def init ( _type , config ) do { :ok , Keyword . put ( config , :url , Fly.Postgres . database_url ( ) ) } end end defmodule Core.Repo do use Fly.Repo , local_repo : MyApp.Repo.Local end Using the same name allows your existing code to seamlessly work with the new repo. When explicitly managing database transactions like using Multi or start_transaction , when used to modify data, those functions should be called by an RPC so they run in the primary region. Fly.RPC . rpc_region ( :primary , MyModule , :my_function_that_uses_multi , [ my , args ] , opts )","ref":"Fly.Repo.html","title":"Fly.Repo","type":"module"},{"doc":"Fly Postgres Helps take advantage of geographically distributed Elixir applications using Ecto and PostgreSQL in a primary/replica configuration on Fly.io . Online Documentation Mark Ericksen's ElixirConf 2021 presentation explaining what this library is for and the problems it helps solve.","ref":"readme.html","title":"Fly Postgres","type":"extras"},{"doc":"If available in Hex , the package can be installed by adding fly_postgres to your list of dependencies in mix.exs : def deps do [ { :fly_postgres , &quot;~&gt; 0.2.0&quot; } ] end Note that fly_postgres depends on fly_rpc so it will be pulled in as well. The configuration section below includes the relevant parts for fly_rpc .","ref":"readme.html#installation","title":"Fly Postgres - Installation","type":"extras"},{"doc":"Repo This assumes your project already has an Ecto.Repo . To start using the Fly.Repo , here are the changes to make. For a project named &quot;MyApp&quot;, change it from this... defmodule MyApp.Repo do use Ecto.Repo , otp_app : :my_app , adapter : Ecto.Adapters.Postgres end To something like this... defmodule MyApp.Repo.Local do use Ecto.Repo , otp_app : :my_app , adapter : Ecto.Adapters.Postgres # Dynamically configure the database url based on runtime environment. def init ( _type , config ) do Fly.Postgres . config_repo_url ( config ) end end defmodule MyApp.Repo do use Fly.Repo , local_repo : MyApp.Repo.Local end This renames your existing repo to &quot;move it out of the way&quot; and adds a new repo to the same file. The new repo uses the Fly.Repo and links back to your project's Ecto.Repo . The new repo has the same name as your original Ecto.Repo , so your application will be referring to it now when talking to the database. The other change was to add the init function to your Ecto.Repo . This dynamically configures your Ecto.Repo to connect to the primary (writable) database when your application is running in the primary region. When your application is not in the primary region, it is configured to connect to the nearest read-only replica. The replica is like a fast local cache of all your data. The .Local idea is that your Ecto.Repo is configured to talk to it's physically &quot;local&quot; database. The Fly.Repo performs all read operations like all , one , and get_by directly on the local replica. Other modifying functions like insert , update , and delete are performed on the primary database through proxy calls to a node in your Elixir cluster running in the primary region. That ability is provided by the fly_rpc library. Migration Files After changing your repo name, generating migrations can end up in the wrong place, or at least not where you want them. You can override the inferred location in your config: config :my_app , MyApp.Repo.Local , priv : &quot;priv/repo&quot; Repo References The goal with using this repo wrapper, is to leave the majority of your application code and business logic unchanged. However, there are a few places that need to be updated to make it work smoothly. The following examples are places in your project code that need reference your actual Ecto.Repo . Following the above example, it should point to MyApp.Repo.Local . test_helper.exs files make references like this Ecto.Adapters.SQL.Sandbox.mode(MyApp.Repo.Local, :manual) data_case.exs files start the repo using Ecto.Adapters.SQL.Sandbox.start_owner! calls. channel_case.exs need to start your local repo. conn_case.exs need to start your local repo. config/config.exs needs to identify your local repo module. Ex: ecto_repos: [MyApp.Repo.Local] config/dev.exs , config/test.exs , config/runtime.exs - any special repo configuration should refer to your local repo. With these project plumbing changes, you application code can stay largely untouched! Primary Region If your application is deployed to multiple Fly.io regions, the instances (or nodes) must be clustered together. Through ENV configuration, you tell the app which region is the &quot;primary&quot; region. fly.toml This example configuration says that the Sydney Australia region is the &quot;primary&quot; region. This is where the primary postgres database is created and where our application has fast write access to it. [env] PRIMARY_REGION = &quot;syd&quot; Application There are two entries to add to your application supervision tree. defmodule MyApp.Application do use Application def start ( _type , _args ) do # ... children = [ # Start the RPC server { Fly.RPC , [ ] } , # Start the Ecto repository MyApp.Repo.Local , # Start the tracker after your DB. { Fly.Postgres.LSN.Tracker , repo : MyApp.Repo.Local } , #... ] # ... end end The following changes were made: Added the Fly.RPC GenServer Start your Repo Added Fly.Postgres.LSN.Tracker telling it which Repo to use. Multiple Ecto.Repos? If you have multiple Ecto.Repo s setup in your application, you can still use Fly.Postgres . You will need an LSN Tracker for each repository that you want to work with. In your application file, it would be similar to this: defmodule MyApp.Application do use Application def start ( _type , _args ) do # ... children = [ # Start the RPC server { Fly.RPC , [ ] } , # Start Ecto repositories MyApp.Repo.Local_1 , MyApp.Repo.Local_2 , # Start the tracker after your DBs and name them. { Fly.Postgres.LSN.Tracker , repo : MyApp.Repo.Local_1 , name : :repo_tracker_1 } , { Fly.Postgres.LSN.Tracker , repo : MyApp.Repo.Local_2 , name : :repo_tracker_2 } , #... ] # ... end end","ref":"readme.html#configuration","title":"Fly Postgres - Configuration","type":"extras"},{"doc":"Local Development If you get an error like (ArgumentError) could not fetch environment variable &quot;PRIMARY_REGION&quot; because it is not set then see the README docs in fly_rpc for details on setting up your local development environment. Automatic Usage Normal calls like MyApp.Repo.all(User) are performed on the local replica repo. They are unchanged and work exactly as you'd expect. Calls that modify the database like &quot;insert, update, and delete&quot;, are performed through an RPC (Remote Procedure Call) in your application running in the primary region. In order for this to work, your application must be clustered together and configured to identify which region is the &quot;primary&quot; region. Additionally, your application needs to be deployed to multiple regions. There must be a deployment in the primary region as well. A call to MyApp.Repo.insert(changeset) will be proxied to perform the insert in the primary region. If the function is already running in the primary region, it just executes normally locally. If the function is running in a non-primary region, it makes a RPC execution to run on the primary. Additionally, it gets the Postgres LSN (Log Sequence Number) for the database after making the change. The calling function then blocks, waits for the async database replication process to complete, and continues on once the data modification has replayed on the local replica. In this way, it becomes seamless for you and your code! You get the benefits of being globally distributed and running closer to your users without re-designing your application! By default, a Repo function that modifies the database is proxied to the server and it waits for the data to be replicated locally before continuing. Passing the await: false option instructs the proxy code to not wait for replication. This is helpful when you only need the function result or the data is not immediately needed locally. MyApp.Repo . insert ( changeset , await : false ) MyApp.Repo . update ( changeset , await : false ) MyApp.Repo . delete ( item , await : false ) Explicit RPC Usage When business logic code makes a number of changes or does some back and forth with the database, the &quot;Automatic Usage&quot; will be too slow. An example is looping though a list and performing a database insert on each iteration. Waiting for the insert to complete and be locally replicated before performing the next iteration could be very slow. For those cases, execute the function that does all the database work but do it in the primary region where it is physically close to the database. Fly.Postgres . rpc_and_wait ( MyModule , :do_complex_work , [ arg1 , arg2 ] ) The function will be executed in the primary region and it blocks locally until any relevant database changes are replicated locally. Explicit RPC but don't Wait for Replication Sometimes you might not want to wait for DB replication. Perhaps it's a fire-and-forget or the function result is enough. For this case, you can use the fly_rpc library directly. Fly . rpc_primary ( MyModule , :do_work , [ arg1 , arg2 ] ) This is a convenience function which is equivalent to the following: Fly.RPC . rpc_region ( :primary , MyModule , :do_work , [ arg1 , arg2 ] ) This also works when modifying the database too.","ref":"readme.html#usage","title":"Fly Postgres - Usage","type":"extras"},{"doc":"The library polls the local database for what point in the replication process it has gotten to. It uses the LSN (Log Sequence Number) to determine that. Using this information, a process making changes against the primary database can request to be notified once the LSN it cares about has been replicated. This enables blocking operations that pause and wait for replication to complete. The active polling only happens once a process has requested to be notified. When there are no pending requests, there is no active polling. Also, there can be many active pending requests and still there will be only 1 polling process. So each waiting process isn't polling the database itself. The polling design scales well and doesn't perform work when there is nothing to track.","ref":"readme.html#lsn-polling","title":"Fly Postgres - LSN Polling","type":"extras"},{"doc":"By default, Fly.io defines some &quot;backup regions&quot; where your app may be deployed. This can happen even during a normal deploy where the app instance created for running database migrations could come up in a backup region. The fly_postgres library makes an important assumption: that the app instance is always running in a region with either the primary or replica database. To make your deployments reliably end up in a desired region, we'll disable the backup regions. Or rather, explicitly set which regions should be use as backup regions. To see you current set of backup regions: fly regions backup list If you want to serve 2 regions like lax and syd , then you can the backup regions like this: fly regions backup lax syd This makes the backup regions only use the desired regions.","ref":"readme.html#backup-regions","title":"Fly Postgres - Backup Regions","type":"extras"},{"doc":"Currently it is possible to be configured for two regions, scale your app to 2 instances and end up with both app instances in the same region ! Clearly, when one app needs to be running in the primary region in order to receive the RPC calls, it's really important that it consistently be there! A Fly.io config option lets us have more control over that. fly scale count 2 --max-per-region 1 Using the --max-per-region 1 ensures each region will not get an unbalanced number like 2 in one place. If your scale count matches up with your desired number of regions, then they will be evenly distributed.","ref":"readme.html#ensuring-a-deployment-in-your-primary-region","title":"Fly Postgres - Ensuring a Deployment in your Primary Region","type":"extras"}]